unit MainU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, Mask, DB, JvMemoryDataset, JvMaskEdit,
  JvCheckedMaskEdit, JvDatePickerEdit, JvDBDatePickerEdit, JvDBControls,
  JvToolEdit, JvExMask, JvBaseEdits;

type
  (*
    The 'Enter' hotkey is assigned to Action1.
    When trying to use the Enter-key to execute an action in the popup, the
    Enter key is 'captured' by the Action and the popup-action is NOt executed.



    The TJvMemoryData is only to be able to the the DB-versions of the controls!
  *)

  TForm1 = class(TForm)
    Action1: TAction;
    ActionList1: TActionList;
    Button1: TButton;
    DataSource1: TDataSource;
    JvCalcEdit1: TJvCalcEdit;
    JvCalcEdit2: TJvCalcEdit;
    JvDateEdit1: TJvDateEdit;
    JvDateEdit2: TJvDateEdit;
    JvDBCalcEdit1: TJvDBCalcEdit;
    JvDBCalcEdit2: TJvDBCalcEdit;
    JvDBDateEdit1: TJvDBDateEdit;
    JvDBDateEdit2: TJvDBDateEdit;
    JvDBDatePickerEdit1: TJvDBDatePickerEdit;
    JvDBDatePickerEdit2: TJvDBDatePickerEdit;
    JvMemoryData1: TJvMemoryData;
    JvMemoryData1TEST_DATE: TDateField;
    JvMemoryData1TEST_NUM: TFloatField;
    Label1: TLabel;
    Label2: TLabel;
    procedure Action1Execute(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure DisableActions(Sender: TObject);
    procedure EnableActions(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses
  TypInfo;

type
  THackJvCustomComboEdit = class(TJvCustomComboEdit);

{$R *.dfm}

procedure TForm1.Action1Execute(Sender: TObject);
begin
  ShowMessage('Enter key pressed');
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  Obj: TControl;
  mShown, mHidden: TMethod;
  pi: PPropInfo;
begin
  // Sample code for setting events using (old) Rtti

  // Create method references
  mShown.Data := Self;
  mShown.Code := @TForm1.DisableActions;
  mHidden.Data := Self;
  mHidden.Code := @TForm1.EnableActions;

  // Loop controls
  for I := 0 to ControlCount - 1 do
  begin
    Obj := Controls[I];

    // When property exists, assign the new event (when none is set...)
    pi := GetPropInfo(Obj, 'OnPopupShown');
    if Assigned(pi) and (GetMethodProp(Obj, pi).Data = nil)  then
      SetMethodProp(Obj, pi, mShown);

    // When property exists, assign the new event (when none is set...)
    pi := GetPropInfo(Obj, 'OnPopupHidden');
    if Assigned(pi) and (GetMethodProp(Obj, pi).Data = nil)  then
      SetMethodProp(Obj, pi, mHidden);
  end;
end;

procedure TForm1.DisableActions(Sender: TObject);
begin
  ActionList1.State := asSuspended;
end;

procedure TForm1.EnableActions(Sender: TObject);
begin
  ActionList1.State := asNormal;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Hook evnts using THackJvCustomComboEdit class...
  THackJvCustomComboEdit(JvCalcEdit2).OnPopupShown := DisableActions;
  THackJvCustomComboEdit(JvCalcEdit2).OnPopupHidden := EnableActions;
  THackJvCustomComboEdit(JvDBCalcEdit2).OnPopupShown := DisableActions;
  THackJvCustomComboEdit(JvDBCalcEdit2).OnPopupHidden := EnableActions;

  THackJvCustomComboEdit(JvDateEdit2).OnPopupShown := DisableActions;
  THackJvCustomComboEdit(JvDateEdit2).OnPopupHidden := EnableActions;
  THackJvCustomComboEdit(JvDBDateEdit2).OnPopupShown := DisableActions;
  THackJvCustomComboEdit(JvDBDateEdit2).OnPopupHidden := EnableActions;

  THackJvCustomComboEdit(JvDBDatePickerEdit2).OnPopupShown := DisableActions;
  THackJvCustomComboEdit(JvDBDatePickerEdit2).OnPopupHidden := EnableActions;
end;

end.
